from gtcdata.loader import gtcData1d
from gtcdata.visualizer import Data1dVisualizer as dv
import matplotlib.pyplot as plt
import numpy as np
import tkinter as tk


def data1d_window(selfi, path, file_type=0):

    if file_type==0:
        filename = path+"/data1d.bp"
    elif file_type==1:
        filename = path+"/data1d.out"

    d1ddata = gtcData1d(filename, verbose=True)

    myDV = dv(d1ddata,selfi)
    # test lines:
    #print(myDV._data_file)
    #print(d1ddata.data1de)
    #print(d1ddata.data1de.shape)
    #print(d1ddata.ndstep)


    ## functions for GUI

    ## GUI for plots

    window = tk.Toplevel(selfi)
    #window = tk.Tk()
    #window.pack_propagate(0) #prevent the window from shrinking
    window.title("Data1d panel")
    # window.geometry('500x300')

    # Plot 1
    #lbl1 = tk.Label(window, text="Catagory 1", height=1, width=13)
    #lbl1.grid(column=0, row=0)
    def clicked1():
        myDV.contour_ion_part_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="ion flux", command=clicked1, height=1, width=10)
    btn1.grid(column=1, row=1)

    # Plot 2
    #lbl2 = tk.Label(window, text="Catagory 2", height=1, width=13)
    #lbl2.grid(column=0, row=1)
    def clicked2():
        myDV.contour_ion_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy flux", command=clicked2, height=1, width=10)#, state='disabled')
    btn1.grid(column=1, row=2)
    
    ####
    def clicked3():
        myDV.contour_e_part_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="electron flux", command=clicked3, height=1, width=10)
    btn1.grid(column=2, row=1)
    """
    """ 
    ####
    def clicked4():
        myDV.contour_e_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy flux", command=clicked4, height=1, width=10)
    btn1.grid(column=2, row=2)

    #####
    def clicked5():
        myDV.contour_ep_part_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="EP flux", command=clicked5, height=1, width=10)
    btn1.grid(column=3, row=1)

    ####
    def clicked6():
        myDV.contour_ep_ene_flux()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="energy flux", command=clicked6, height=1, width=10)
    btn1.grid(column=3, row=2)

    ####
    def clicked7():
        myDV.contour_zonal_flow()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="phi00", command=clicked7, height=1, width=10)#, state='disabled')
    btn1.grid(column=4, row=1)
    
    ####
    def clicked8():
        myDV.contour_phi_rms()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="phi_rms", command=clicked8, height=1, width=10)
    btn1.grid(column=4, row=2)

    ####
    def clicked9():
        myDV.contour_zonal_i()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="apara00", command=clicked9, height=1, width=10)
    btn1.grid(column=5, row=1)

    #####
    def clicked10():
        myDV.contour_apara_rms()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="apara_rms", command=clicked10, height=1, width=10)
    btn1.grid(column=5, row=2)

    ####
    def clicked11():
        myDV.contour_zonal_fluid()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="fluidne00", command=clicked11, height=1, width=10)
    btn1.grid(column=6, row=1)

    ####
    def clicked12():
        myDV.contour_fluid_rms()
#        plt.show(block=False)
    btn1 = tk.Button(window, text="fluidne_rms", command=clicked12, height=1, width=10)#, state='disabled')
    btn1.grid(column=6, row=2)

    #######################################

    #change the time range for the plot
    var_nstart = tk.StringVar()
    txt_nstart = tk.Entry(window,width=10,textvariable=var_nstart)
    txt_nstart.grid(column=8, row=1)
    var_nstart.set(myDV.nstart)
    var_nend = tk.StringVar()
    txt_nend = tk.Entry(window,width=10,textvariable=var_nend)
    txt_nend.grid(column=9, row=1)
    var_nend.set(myDV.nend)
    def clicked_trange():
        if var_nstart.get()=="" or var_nend.get()=="":
            var_nstart.set(myDV.nstart)
            var_nend.set(myDV.nend)
        else:
            myDV.nstart = int(var_nstart.get())
            myDV.nend = int(var_nend.get())
    btn_edit = tk.Button(window, text="time range", command=clicked_trange, height=1, width=10)
    btn_edit.grid(column=7, row=1)

    lb_trange = tk.Label(window, text = "range: ("+ str(myDV.nstart) +', '+ str(myDV.nend) +')')
    lb_trange.grid(column = 10, row = 1)

    #change the mpsi range for the plot
    var_m0 = tk.StringVar()
    txt_m0 = tk.Entry(window,width=10,textvariable=var_m0)
    txt_m0.grid(column=8, row=2)
    var_m0.set(myDV.m0)
    var_m1 = tk.StringVar()
    txt_m1 = tk.Entry(window,width=10,textvariable=var_m1)
    txt_m1.grid(column=9, row=2)
    var_m1.set(myDV.m1)
    def clicked_mpsirange():
        if var_m0.get()=="" or var_m1.get()=="":
            var_m0.set(myDV.m0)
            var_m1.set(myDV.m1)
        else:
            myDV.m0 = int(var_m0.get())
            myDV.m1 = int(var_m1.get())
    btn_edit = tk.Button(window, text="mpsi range", command=clicked_mpsirange, height=1, width=10)
    btn_edit.grid(column=7, row=2)

    lb_mrange = tk.Label(window, text = "range: ("+ str(myDV.m0) +', '+ str(myDV.m1) +')')
    lb_mrange.grid(column = 10, row = 2)

    #change the cutoff value for the flux range
    var_cutoff = tk.StringVar()
    txt_cutoff = tk.Entry(window,width=10,textvariable=var_cutoff)
    txt_cutoff.grid(column=8, row=3)
    var_cutoff.set(myDV.cutoff)
    def clicked_cutoff():
        if var_cutoff.get()=="":
            var_cutoff.set(myDV.cutoff)
        else:
            myDV.cutoff = float(var_cutoff.get())
            var_cutoff.set(myDV.cutoff)
    btn_edit = tk.Button(window, text="legend_cutoff", command=clicked_cutoff, height=1, width=10)
    btn_edit.grid(column=7, row=3)

    lb_cutoff = tk.Label(window, text = "("+ str(0.0) +', '+ str(myDV.cutoff) +')')
    lb_cutoff.grid(column = 9, row = 3)

    #select the method to refresh figures
    select_plt = tk.IntVar() 
    select_plt.set(0)
    def click_slct():
        myDV.plot_mode = int(select_plt.get())
        if myDV.plot_mode == 1:
            print('plot mode changes to "New Figs"')
        elif myDV.plot_mode == 0:
            print('plot mode changes to "Refresh"')
        else:
            print('error: wrong input for plot mode')
    rad1 = tk.Radiobutton(window,text='New Figs', value=1, 
                        variable=select_plt, command=click_slct, width=10)
    rad1.grid(column=7, row=4)
    rad2 = tk.Radiobutton(window,text='Refresh', value=0, 
                        variable=select_plt, command=click_slct, width=10)
    rad2.grid(column=8, row=4)

    #######################################

    # Button to reset all settings of the main window
    def click_reset():
        myDV.nstart = 0
        var_nstart.set(myDV.nstart)
        myDV.nend = myDV._data.ndstep-1
        var_nend.set(myDV.nend)

        myDV.m0 = 0
        var_m0.set(myDV.m0)
        myDV.m1 = myDV._data.__dict__["mpsi+1"] -1
        var_m1.set(myDV.m1)

        myDV.cutoff = 1.0
        var_cutoff.set(myDV.cutoff)
        
        myDV.plot_mode = 0
        select_plt.set(0)
    btn_reset = tk.Button(window, text="reset", fg="red", 
                          command=click_reset, height=1, width=10)
    btn_reset.grid(column=12, row=13)

    # Button to quit the main window
    btn_quit = tk.Button(window, text="Quit", fg="red", 
                        command=window.destroy, height=1, width=10)
    btn_quit.grid(column=13, row=13)

    window.mainloop()

    ## test functions

    #myEV.print_test()
    #input("press Enter...")

    #plt.show(block=False)
    #input("press Enter to close plots")

